package net.mcreator.fishytest.procedures;

import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.common.MinecraftForge;

import net.minecraft.world.World;
import net.minecraft.world.IWorld;
import net.minecraft.util.text.StringTextComponent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.potion.Effects;
import net.minecraft.potion.EffectInstance;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.Entity;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.block.Block;

import net.mcreator.fishytest.enchantment.SmashEnchantment;
import net.mcreator.fishytest.FishytestModVariables;
import net.mcreator.fishytest.FishytestModElements;

import java.util.Map;
import java.util.HashMap;

@FishytestModElements.ModElement.Tag
public class SmashProcedureProcedure extends FishytestModElements.ModElement {
	public SmashProcedureProcedure(FishytestModElements instance) {
		super(instance, 7);
		MinecraftForge.EVENT_BUS.register(this);
	}

	public static void executeProcedure(Map<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure SmashProcedure!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure SmashProcedure!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure SmashProcedure!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure SmashProcedure!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure SmashProcedure!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		double x = dependencies.get("x") instanceof Integer ? (int) dependencies.get("x") : (double) dependencies.get("x");
		double y = dependencies.get("y") instanceof Integer ? (int) dependencies.get("y") : (double) dependencies.get("y");
		double z = dependencies.get("z") instanceof Integer ? (int) dependencies.get("z") : (double) dependencies.get("z");
		IWorld world = (IWorld) dependencies.get("world");
		ItemStack chestplate = ItemStack.EMPTY;
		double for_x = 0;
		double for_z = 0;
		chestplate = ((entity instanceof PlayerEntity) ? ((PlayerEntity) entity).inventory.armorInventory.get(2) : ItemStack.EMPTY);
		if (((entity.isSneaking()) && ((EnchantmentHelper.getEnchantmentLevel(SmashEnchantment.enchantment, (chestplate))) == 1))) {
			if (entity instanceof PlayerEntity) {
				((PlayerEntity) entity).abilities.disableDamage = (true);
				((PlayerEntity) entity).sendPlayerAbilities();
			}
			if (entity instanceof LivingEntity)
				((LivingEntity) entity).addPotionEffect(new EffectInstance(Effects.SLOWNESS, (int) 1, (int) 5));
			entity.setMotion(0, (-1.5), 0);
			if (((world.getBlockState(new BlockPos((int) x, (int) (y - 1), (int) (z - 1))).isSolid())
					&& (((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
							.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) == 0))) {
				for_x = (double) (-1);
				for (int index0 = 0; index0 < (int) (3); index0++) {
					for_z = (double) (-2);
					for (int index1 = 0; index1 < (int) (3); index1++) {
						if (((world.getBlockState(new BlockPos((int) (x + (for_x)), (int) (y - 1), (int) (z + (for_z)))).getBlockHardness(world,
								new BlockPos((int) (x + (for_x)), (int) (y - 1), (int) (z + (for_z))))) >= 0)) {
							Block.spawnDrops(world.getBlockState(new BlockPos((int) (x + (for_x)), (int) (y - 1), (int) (z + (for_z)))),
									world.getWorld(), new BlockPos((int) (x + (for_x)), (int) (y - 1), (int) (z + (for_z))));
							world.destroyBlock(new BlockPos((int) (x + (for_x)), (int) (y - 1), (int) (z + (for_z))), false);
						}
						for_z = (double) ((for_z) + 1);
					}
					for_x = (double) ((for_x) + 1);
				}
				{
					double _setval = (double) 100;
					entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null).ifPresent(capability -> {
						capability.smash_cooldown = _setval;
						capability.syncPlayerVariables(entity);
					});
				}
			}
		} else if ((((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
				.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) > 0)) {
			{
				double _setval = (double) (((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
						.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) - 1);
				entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null).ifPresent(capability -> {
					capability.smash_cooldown = _setval;
					capability.syncPlayerVariables(entity);
				});
			}
			if (((((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
					.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) % 20) == 0)) {
				if ((((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
						.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) == 0)) {
					if (entity instanceof PlayerEntity && !entity.world.isRemote) {
						((PlayerEntity) entity).sendStatusMessage(new StringTextComponent("Ready!"), (true));
					}
				} else {
					if (entity instanceof PlayerEntity && !entity.world.isRemote) {
						((PlayerEntity) entity).sendStatusMessage(
								new StringTextComponent(("" + ((((entity.getCapability(FishytestModVariables.PLAYER_VARIABLES_CAPABILITY, null)
										.orElse(new FishytestModVariables.PlayerVariables())).smash_cooldown) / 20)))),
								(true));
					}
				}
			}
			if (entity instanceof PlayerEntity) {
				((PlayerEntity) entity).abilities.disableDamage = (false);
				((PlayerEntity) entity).sendPlayerAbilities();
			}
		} else {
			if (entity instanceof PlayerEntity) {
				((PlayerEntity) entity).abilities.disableDamage = (false);
				((PlayerEntity) entity).sendPlayerAbilities();
			}
		}
	}

	@SubscribeEvent
	public void onPlayerTick(TickEvent.PlayerTickEvent event) {
		if (event.phase == TickEvent.Phase.END) {
			Entity entity = event.player;
			World world = entity.world;
			double i = entity.getPosX();
			double j = entity.getPosY();
			double k = entity.getPosZ();
			Map<String, Object> dependencies = new HashMap<>();
			dependencies.put("x", i);
			dependencies.put("y", j);
			dependencies.put("z", k);
			dependencies.put("world", world);
			dependencies.put("entity", entity);
			dependencies.put("event", event);
			this.executeProcedure(dependencies);
		}
	}
}
